package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import javax.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class Evaluation (
        @Expose @Id @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull var evaluationId: Int,
        @Expose @get: NonNull var exerciseTypeId: Long = 0,
        @Expose @get: NotBlank var name: String = "",
        @Expose @get: NonNull var unit: String = "",
) {
        @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "evaluation")
        @Fetch(value = FetchMode.SUBSELECT)
        @Expose val attributes: List<EvaluationAttribute> = mutableListOf()
}