package com.aitrainer.api.model

import com.fasterxml.jackson.annotation.JsonIgnore
import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import javax.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class TutorialSteps (
    @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull var tutorialStepId: Long = 0,
    @Expose @get: NotBlank  var tutorialText: String = "",
    @Expose @get: NotBlank var step: Int = 0,
    @Expose var direction: String? = null,
    @Expose var checkText: String? = null,
    @Expose var condition: String? = null,
    @Expose var branch: String? = null,
    @Expose @get: NotBlank var parent_id: Int = 0,
    @Expose var action: Int? = 0,
) {

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "tutorialId", nullable = false)
    @JsonIgnore
    val tutorial: Tutorial? = null

    @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "tutorialSteps")
    @Fetch(value = FetchMode.SUBSELECT)
    @Expose val translations: List<TutorialTranslation> = mutableListOf<TutorialTranslation>().toList()


}