package com.aitrainer.api.repository

import com.aitrainer.api.model.ExerciseDevice
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.stereotype.Repository

@Repository
interface ExerciseDeviceRepository: JpaRepository<ExerciseDevice, Long> {
    @Query("FROM ExerciseDevice as e "  +
            "LEFT JOIN ExerciseDeviceTranslation as t ON e.exerciseDeviceId = t.exerciseDevice AND t.languageCode = 'hu' " +
            "LEFT JOIN ExerciseDeviceAlternative as t ON e.exerciseDeviceId = t.exerciseDevice " +
            "ORDER BY e.exerciseDeviceId ")
    fun getExerciseDevices(): List<ExerciseDevice>
}