package com.aitrainer.api.repository

import com.aitrainer.api.model.ExerciseTree
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query
import org.springframework.stereotype.Repository

@Repository
interface ExerciseTreeRepository : JpaRepository<ExerciseTree, Long> {

    @Query("FROM ExerciseTree as e "  +
            "LEFT JOIN ExerciseTreeTranslation as t ON e.treeId = t.exerciseTree AND t.languageCode = 'hu' " +
            "LEFT JOIN ExerciseTreeAbility as t ON e.treeId = t.exerciseTree " +
            "WHERE e.active = 1 " +
            "ORDER BY e.treeId ")
    fun getActiveMenu(): List<ExerciseTree>
}