package com.aitrainer.api.test

import com.aitrainer.api.controller.SportController
import com.aitrainer.api.repository.SportRepository
import org.junit.jupiter.api.Test
import org.junit.jupiter.api.TestInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import kotlin.test.assertEquals
import kotlin.test.assertTrue

@SpringBootTest
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
class SportTest {

    @Autowired
    private lateinit var sportRepository: SportRepository


    @Test
    fun testGetSports() {
        val controller = SportController(sportRepository )
        val response = controller.getSportsWithTranslation()

        val sports = response.body

        assertTrue(sports is List)
        assertTrue(sports.isNotEmpty())
        assertEquals(sports.size, 4)
        assertEquals(sports[1].name, "Football")
        assertEquals(sports[1].translations[0].sportName, "Labdarúgás")
        assertEquals(sports[2].name, "Footgolf")
        assertEquals(sports[2].translations[0].sportName, "Footgolf")
        assertEquals(sports[3].translations[0].sportName, "Tenisz")
    }

}